/* LPPERS.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer icon, ifeas, inputs[19], incol, inn, io1, io2, io3, iouts[4], 
	    itry, iver, jin, jjout, jout, lenreq, lop, m1, mle, n1, ncall, 
	    ncost, neql, numnz;
} lppzzi_;

#define lppzzi_1 lppzzi_

struct {
    doublereal errs[4], tols[4];
} lppzzr_;

#define lppzzr_1 lppzzr_

/* Subroutine */ int lppers_(jx, a, kt, cost, rhs, pi, x, dj)
integer *jx;
doublereal *a;
integer *kt;
doublereal *cost, *rhs, *pi, *x, *dj;
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
#define invc ((integer *)&lppzzi_1 + 28)
#define iter ((integer *)&lppzzi_1 + 27)
#define ncut ((integer *)&lppzzi_1 + 11)
#define nver ((integer *)&lppzzi_1 + 13)
#define tpiv ((doublereal *)&lppzzr_1 + 4)
    static integer i__, j;
#define k ((integer *)&lppzzi_1 + 26)
#define m ((integer *)&lppzzi_1 + 4)
#define n ((integer *)&lppzzi_1 + 5)
#define jfile ((integer *)&lppzzi_1 + 19)
#define iline ((integer *)&lppzzi_1 + 17)
#define tfeas ((doublereal *)&lppzzr_1 + 6)
#define lenws ((integer *)&lppzzi_1 + 7)
    static doublereal error;
#define iprnt ((integer *)&lppzzi_1 + 15)
#define tcost ((doublereal *)&lppzzr_1 + 5)
#define itryo ((integer *)&lppzzi_1 + 14)
#define numvr ((integer *)&lppzzi_1 + 29)
    static integer ii;
#define ml ((integer *)&lppzzi_1 + 2)
#define nl ((integer *)&lppzzi_1 + 3)
#define inflag ((integer *)&lppzzi_1 + 8)
#define ipdata ((integer *)&lppzzi_1 + 16)
#define jfinal ((integer *)&lppzzi_1 + 18)
    static doublereal ss;
#define ialleq ((integer *)&lppzzi_1 + 9)
#define kslack ((integer *)&lppzzi_1 + 10)
#define tx ((doublereal *)lppzzr_1 + 7)
    extern /* Subroutine */ int lppdel_();
#define colmax ((doublereal *)&lppzzr_1 + 2)
#define minmax ((integer *)&lppzzi_1 + 6)
#define jwidth ((integer *)&lppzzi_1 + 20)
    static doublereal dj1;
#define colsum ((doublereal *)&lppzzr_1 + 3)
#define rowmax ((doublereal *)&lppzzr_1)
#define rowsum ((doublereal *)&lppzzr_1 + 1)
#define neq ((integer *)&lppzzi_1 + 12)
    static integer jss;


/*     COMPUTES ERRORS AND SETS EXIT VALUES */





/*     STORE  A*Z - RHS  IN FIRST M CO-ORDINATES OF DJ. */
/*     COMPUTE SUM OF ABSOLUTE VALUES. */

/*     COMPUTE  A*Z - RHS. */

    /* Parameter adjustments */
    --dj;
    --x;
    --pi;
    --rhs;
    --cost;
    --kt;
    --a;
    --jx;

    /* Function Body */
    i__1 = *m;
    for (ii = 1; ii <= i__1; ++ii) {
	dj[ii] = -rhs[ii];
	ss = dj[ii];
	i__2 = *m;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    if (jx[i__] == 0) {
		goto L100;
	    }
	    jss = jx[i__] - *n;
	    if (jss > 0) {
		goto L90;
	    }
	    j = ii + (jx[i__] - 1) * *ml;
	    if (a[j] == 0.) {
		goto L100;
	    }
	    if (x[i__] == 0.) {
		goto L100;
	    }
	    ss += a[j] * x[i__];
	    goto L100;
L90:
	    j = jx[i__] - *n;
	    if (j == ii) {
		ss += (doublereal) kt[j] * x[i__];
	    }
L100:
	    ;
	}
	error = abs(ss);
	*rowsum += error;
	if (error >= *rowmax) {
	    *rowmax = error;
	}
/* L200: */
    }

/*     FIND SUM AND MAXIMUM OF REDUCED COSTS IN BASIS. */

/* L250: */
    i__1 = lppzzi_1.n1;
    for (j = 1; j <= i__1; ++j) {
	lppdel_(&j, &dj1, &a[1], &kt[1], &cost[1], &pi[1]);
	dj[j] = dj1;
/* L260: */
    }
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	j = jx[i__];
	if (j == 0) {
	    goto L300;
	}
	dj1 = dj[j];
	error = abs(dj1);
	*colsum += error;
	if (error > *colmax) {
	    *colmax = error;
	}
L300:
	;
    }

    return 0;

} /* lppers_ */

#undef neq
#undef rowsum
#undef rowmax
#undef colsum
#undef jwidth
#undef minmax
#undef colmax
#undef tx
#undef kslack
#undef ialleq
#undef jfinal
#undef ipdata
#undef inflag
#undef nl
#undef ml
#undef numvr
#undef itryo
#undef tcost
#undef iprnt
#undef lenws
#undef tfeas
#undef iline
#undef jfile
#undef n
#undef m
#undef k
#undef tpiv
#undef nver
#undef ncut
#undef iter
#undef invc


