/* LPPPIV.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer icon, ifeas, inputs[19], incol, inn, io1, io2, io3, iouts[4], 
	    itry, iver, jin, jjout, jout, lenreq, lop, m1, mle, n1, ncall, 
	    ncost, neql, numnz;
} lppzzi_;

#define lppzzi_1 lppzzi_

struct {
    doublereal errs[4], tols[4];
} lppzzr_;

#define lppzzr_1 lppzzr_

/* Subroutine */ int lpppiv_(irow, y, x, e)
integer *irow;
doublereal *y, *x, *e;
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;

    /* Local variables */
#define invc ((integer *)&lppzzi_1 + 28)
#define iter ((integer *)&lppzzi_1 + 27)
#define ncut ((integer *)&lppzzi_1 + 11)
#define nver ((integer *)&lppzzi_1 + 13)
#define tpiv ((doublereal *)&lppzzr_1 + 4)
    static integer jrow, i__, j;
#define k ((integer *)&lppzzi_1 + 26)
#define m ((integer *)&lppzzi_1 + 4)
#define n ((integer *)&lppzzi_1 + 5)
#define jfile ((integer *)&lppzzi_1 + 19)
    static doublereal z__;
#define iline ((integer *)&lppzzi_1 + 17)
#define tfeas ((doublereal *)&lppzzr_1 + 6)
#define lenws ((integer *)&lppzzi_1 + 7)
#define iprnt ((integer *)&lppzzi_1 + 15)
#define tcost ((doublereal *)&lppzzr_1 + 5)
#define itryo ((integer *)&lppzzi_1 + 14)
#define numvr ((integer *)&lppzzi_1 + 29)
    static doublereal ee;
    static integer ii;
#define ml ((integer *)&lppzzi_1 + 2)
#define nl ((integer *)&lppzzi_1 + 3)
    static integer mm;
#define inflag ((integer *)&lppzzi_1 + 8)
#define ipdata ((integer *)&lppzzi_1 + 16)
#define jfinal ((integer *)&lppzzi_1 + 18)
#define ialleq ((integer *)&lppzzi_1 + 9)
#define kslack ((integer *)&lppzzi_1 + 10)
#define tx ((doublereal *)&lppzzr_1 + 7)
#define colmax ((doublereal *)&lppzzr_1 + 2)
#define minmax ((integer *)&lppzzi_1 + 6)
#define jwidth ((integer *)&lppzzi_1 + 20)
#define colsum ((doublereal *)&lppzzr_1 + 3)
#define rowmax ((doublereal *)&lppzzr_1)
#define rowsum ((doublereal *)&lppzzr_1 + 1)
    static integer iii;
#define neq ((integer *)&lppzzi_1 + 12)


/*     TRANSFORMS X AND E BY PIVOTING, I.E., USING THE TRANSFORMATION */
/*     UNEW = UOLD + UR*PHI WHERE U IS A COLUMN VECTOR AND */
/*     PHI = (-Y1/YR,....1/YR-1,....-YM/YR) */






/*     TRANSFORM E. */

    /* Parameter adjustments */
    --e;
    --x;
    --y;

    /* Function Body */
    jrow = *irow;
    mm = 0;
    z__ = y[jrow];
    y[jrow] = -1.;
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	iii = jrow + mm;
	if ((d__1 = e[iii], abs(d__1)) <= *tx) {
	    goto L110;
	}
	ee = e[iii] / z__;
	e[iii] = 0.;
	i__2 = lppzzi_1.m1;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    ii = i__ + mm;
	    if ((d__1 = y[i__], abs(d__1)) <= *tx) {
		goto L100;
	    }
	    e[ii] -= y[i__] * ee;
L100:
	    ;
	}
L110:
	mm += lppzzi_1.mle;
/* L120: */
    }

/*     TRANSFORM X. */

    if ((d__1 = x[jrow], abs(d__1)) <= *tx) {
	goto L210;
    }
    ee = x[jrow] / z__;
    x[jrow] = 0.;
    i__1 = lppzzi_1.m1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if ((d__1 = y[i__], abs(d__1)) <= *tx) {
	    goto L200;
	}
	x[i__] -= y[i__] * ee;
L200:
	;
    }
L210:
    y[jrow] = z__;

    return 0;

} /* lpppiv_ */

#undef neq
#undef rowsum
#undef rowmax
#undef colsum
#undef jwidth
#undef minmax
#undef colmax
#undef tx
#undef kslack
#undef ialleq
#undef jfinal
#undef ipdata
#undef inflag
#undef nl
#undef ml
#undef numvr
#undef itryo
#undef tcost
#undef iprnt
#undef lenws
#undef tfeas
#undef iline
#undef jfile
#undef n
#undef m
#undef k
#undef tpiv
#undef nver
#undef ncut
#undef iter
#undef invc


