/* LPPRIM.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer icon, ifeas, inputs[19], incol, inn, io1, io2, io3, iouts[4], 
	    itry, iver, jin, jjout, jout, lenreq, lop, m1, mle, n1, ncall, 
	    ncost, neql, numnz;
} lppzzi_;

#define lppzzi_1 lppzzi_

struct {
    doublereal errs[4], tols[4];
} lppzzr_;

#define lppzzr_1 lppzzr_

struct {
    doublereal c__, deltaj, ob, rat, suminf;
} lppzzd_;

#define lppzzd_1 lppzzd_

/* Subroutine */ int lpprim_(a, kt, rhs, cost, input, tol, obj, x, jx, pi, dj,
	 err, iout, ws)
doublereal *a;
integer *kt;
doublereal *rhs, *cost;
integer *input;
doublereal *tol, *obj, *x;
integer *jx;
doublereal *pi, *dj, *err;
integer *iout;
doublereal *ws;
{
    /* Initialized data */

    static integer ncall0 = 0;

    /* System generated locals */
    integer i__1;

    /* Local variables */
#define invc ((integer *)&lppzzi_1 + 28)
#define iter ((integer *)&lppzzi_1 + 27)
#define ncut ((integer *)&lppzzi_1 + 11)
#define nver ((integer *)&lppzzi_1 + 13)
#define tpiv ((doublereal *)&lppzzr_1 + 4)
    static integer i__;
#define k ((integer *)&lppzzi_1 + 26)
#define m ((integer *)&lppzzi_1 + 4)
#define n ((integer *)&lppzzi_1 + 5)
#define jfile ((integer *)&lppzzi_1 + 19)
#define iline ((integer *)&lppzzi_1 + 17)
#define tfeas ((doublereal *)&lppzzr_1 + 6)
#define lenws ((integer *)&lppzzi_1 + 7)
#define iprnt ((integer *)&lppzzi_1 + 15)
#define tcost ((doublereal *)&lppzzr_1 + 5)
    static integer l1;
#define itryo ((integer *)&lppzzi_1 + 14)
#define numvr ((integer *)&lppzzi_1 + 29)
    extern /* Subroutine */ int lpprm2_();
#define ml ((integer *)&lppzzi_1 + 2)
#define nl ((integer *)&lppzzi_1 + 3)
#define inflag ((integer *)&lppzzi_1 + 8)
#define ipdata ((integer *)&lppzzi_1 + 16)
#define jfinal ((integer *)&lppzzi_1 + 18)
#define ialleq ((integer *)&lppzzi_1 + 9)
#define kslack ((integer *)&lppzzi_1 + 10)
#define tx ((doublereal *)&lppzzr_1 + 7)
#define colmax ((doublereal *)&lppzzr_1 + 2)
#define minmax ((integer *)&lppzzi_1 + 6)
#define jwidth ((integer *)&lppzzi_1 + 20)
#define colsum ((doublereal *)&lppzzr_1 + 3)
#define rowmax ((doublereal *)&lppzzr_1)
#define rowsum ((doublereal *)&lppzzr_1 + 1)
#define neq ((integer *)&lppzzi_1 + 12)


/*           MADISON ACADEMIC COMPUTING CENTER */
/*           SUBROUTINE LPPRIM FOR SOLVING LINEAR PROGRAMMING PROGRAMS */
/*           USING THE REVISED PRIMAL PHASE 1 - PHASE 2 SIMPLEX METHOD */
/*           WITH INVERSE IN EXPLICIT FORM. */
/*           FORTRAN 77 VERSION 92.05 */

/*           LPPRIM MINIMIZES OR MAXIMIZES  COST*Z */
/*                  SUBJECT TO             (A,T)*Z = RHS */
/*                                               Z .GE. 0 */
/*           WHERE Z IS AN EXTREME POINT CONSISTING OF STRUCTURAL */
/*           AND SLACK VARIABLES AND T IS A DIAGONAL MATRIX WITH */
/*           T(I,I) = -1,0,+1 CORRSPONDING TO .GE.,.EQ.,.LE. CONSTRAINTS, 
*/
/*           RESPECTIVELY. */
/*           NOTE THAT COSTS MAY BE ASSIGNED TO SLACK VARIABLES IN THIS */
/*           SOMEWHAT MORE GENERAL THAN THE STANDARD L.P. FORMULATION. */

/*     CALLING SEQUENCE ... */
/*     CALL LPPRIM (A,KT,RHS,COST,INPUT,TOL, */
/*    *   OBJ,X,JX,PI,DJ,ERR,IOUT,WS) */

/*     IN WHAT FOLLOWS, */
/*     M = NO. OF CONSTRAINTS, N = NO. OF STRUCTURAL VARIABLES, */

/* A     --- DOUBLE PRECISION CONSTRAINT MATRIX OF SIZE AT LEAST M BY N. 
*/
/* KT    --- INTEGER VECTOR OF CONSTRAINT TYPES OF SIZE AT LEAST M. */
/*           -1,0,+1  MEAN  .GE.,.EQ.,.LE.  RESPECTIVELY */
/*RHS   --- DOUBLE PRECISION VECTOR OF RIGHT-HAND-SIDE VALUES OF SIZE AT L
EAST M.*/
/*COST  --- DOUBLE PRECISION VECTOR OF COSTS OF SIZE AT LEAST N IF NON-ZER
O COSTS*/
/*           ARE NOT ASSIGNED TO SLACKS, AND AT LEAST N+M IF THEY ARE. */
/* INPUT --- INTEGER FIXED CONSTANTS VECTOR OF LENGTH AT LEAST 19 */
/*           CONTAINING */
/* ML      1 ROW DIMENSION OF A IN CALLING PROGRAM.  MINIMUM IS M. */
/* NL      2 COLUMN DIMENSION OF A IN CALLING PROGRAM.  MINIMUM IS N. */
/* M       3 NUMBER OF CONSTRAINTS. */
/* N       4 NUMBER OF VARIABLES. */
/* MINMAX  5 =0 IF OBJECTIVE IS TO BE MINIMIZED, */
/*           =1 IF OBJECTIVE IS TO BE MAXIMIZED. */
/* LENWS   6 DIMENSION OF WS IN CALLING PROGRAM.  MINIMUM IS */
/*           M**2 + 5*M + 6. */
/* INFLAG  7 BASIS CONDITION FLAG. */
/*           =0 NEW PROBLEM, LPPRIM FINDS INITIAL BASIS. */
/*           =1 NEW PROBLEM, FULL OR PARTIAL INITIAL BASIS SPEC. IN JX. */
/*           =2 CHANGES IN RHS AND COST ONLY. */
/*           =3 CHANGES IN RHS ONLY. */
/*           =4 CHANGES IN COST ONLY. */
/* IALLEQ  8 ALL EQUALITY CONSTRAINTS FLAG. */
/*           =0 ALL CONSTRAINTS ARE EQUALITIES. */
/*           =1 CONSTRAINT TYPES ARE SPECIFIED IN KT. */
/* KSLACK  9 ASSIGN ZERO COSTS TO SLACK VARIABLES FLAG. */
/*           =0 NO. */
/*           =1 YES. */
/* NCUT   10 ITERATION LIMIT.  IF .LE. 0, RESET TO 1000. */
/* NEQ    11 CONSECUTIVE EUQAL OBJECTIVE VALUE LIMIT.  IF .LE. 0, */
/*           RESET TO 1000. */
/* NVER   12 REINVERSION FREQUENCY.  IF .LE. 0, RESET TO 30. */
/* ITRYO  13 REINVERT AT OPTIMUM FLAG. */
/*           =0 NO. */
/*           =1 YES. */
/* IPRNT  14 OUTPUT PROBLEM PARAMETERS OPTION. */
/*           =0 NO. */
/*           =1 YES. */
/* IPDATA 15 OUTPUT PROBLEM DATA OPTION. */
/*           =0 NO. */
/*           =1 OUTPUT WITH A MATRIX IN DENSE FORM. */
/*           =2 OUTPUT WITH A MATRIX IN SPARSE FORM. */
/* ILINE  16 OUTPUT INTERMEDIATE OUTPUT. */
/*           =0 NO. */
/*           =1 YES. */
/* JFINAL 17 OUTPUT SOLUTION REPORT OPTION. */
/*           =0 NO. */
/*           =1 OUTPUT SOLUTION REPORT WITHOUT SHADOW PRICES (PI). */
/*           =2 OUTPUT SOLUTION REPORT WITH SHADOW PRICES (PI). */
/* JFILE  18 OPTION TO PRINT OR FILE OUTPUT. */
/*           =0 PRINT ALL OUTPUT. */
/*           =1 PRINT PROB. PARAM. AND SOLN. REP. AND FILE OTHER OUTPUT. 
*/
/*           =2 FILE ALL OUTPUT. */
/* JWIDTH 19 MAXIMUM WIDTH OF OUTPUT LINES.  A MINIMUM OF 72 AND A */
/*           MAXIMUM OF 132 WILL BE USED. */
/*TOL   --- DOUBLE PRECISION TOLERANCE VECTOR OF LENGTH AT LEAST 4 CONTAIN
ING*/
/* TPIV    1 PIVOT TOLERANCE.   IF .LE. 0, RESET TO 1.E-7. */
/* TCOST   2 REDUCED COSTS TOLERANCE.   IF .LE. 0, RESET TO 1.E-6. */
/* TFEAS   3 FEASIBILITY TOLERANCE.   IF .LE. 0, RESET TO 1.E-6. */
/* TX      4 ROUND-OFF TOLERANCE.   IF .LE. 0, RESET TO 1.E-10. */
/* OBJ   --- DOUBLE PRECISION OBJECTIVE VALUE. */
/* X     --- DOUBLE PRECISION VECTOR OF LENGTH AT LEAST M+2 THAT WILL */
/*           CONTAIN THE VALUES OF THE BASIC VARIABLES OF THE SOLUTION. */
/*           USED IN CONJUNCTION WITH JX TO DETERMINE SOLUTION VECTOR. */
/*           (THE LAST 2 LOCATIONS ARE NEEDED FOR TEMP. STORAGE.) */
/* JX    --- INTEGER VECTOR OF LENGTH AT LEAST M INDICATING INDICES OF */
/*           VARIABLES IN BASIS. */
/*           1 - N ARE STRUCTURALS, N+1 - N+M ARE SLACKS, 0 IS ARTIF. */
/*           SPECIFIES INITIAL BASIS IF INPUT(7)=1. */
/* PI    --- DOUBLE PRECISION VECTOR OF LENGTH AT LEAST M THAT WILL */
/*           CONTAIN THE SHADOW PRICES. */
/* DJ    --- DOUBLE PRECISION VECTOR THAT WILL CONTAIN THE REDUCED COSTS 
*/
/*           OF LENGTH AT LEAST M+N IF ANY INEQUALITY CONSTRAINTS ARE */
/*           PRESENT OR N FOR ALL EQUALITY PROBLEMS. */
/*ERR   --- DOUBLE PRECISION ERRORS VECTOR OF LENGTH AT LEAST 4 THAT WILL 
CONTAIN*/
/* ROWMAX  1 MAXIMUM ROW ERROR. */
/* ROWSUM  2 SUM OF ROW ERRORS. */
/* COLMAX  3 MAXIMUM COLUMN ERROR. */
/* COLSUM  4 SUM OF COLUMN ERRORS. */
/* IOUT  --- INTEGER VECTOR OF LENGTH AT LEAST 4 THAT WILL CONTAIN */
/* K       1 STATUS CODE FROM 1 TO 6. */
/*           1 - SOLUTION IS OPTIMAL. */
/*           2 - NO FEASIBLE SOLUTION. */
/*           3 - UNBOUNDED SOLUTION. */
/*           4 - ITERATION LIMIT REACHED. */
/*           5 - EQUAL CONSECUTIVE OBJECTIVE LIMIT REACHED. */
/*           6 - PROBLEM DATA ERROR. */
/* ITER    2 NUMBER OF ITERATIONS. */
/* INVC    3 NUMBER OF ITERATIONS SINCE LAST INVERSION. */
/* NUMVR   4 NUMBER OF INVERSIONS. */
/* WS    --- DOUBLE PRECISION WORK SPACE ARRAY OF SIZE AT LEAST */
/*           M**2 + 5*M + 6. */
/*           THE FIRST (M+2)*(N+2) LOCATIONS OF WS CONTAIN THE */
/*           INVERSE OF THE BASIS MATRIX. */

/*     VARIABLES OCCURING IN COMMON BLOCKS. */

/*     C      - CONSTANT = 1000. */
/*     DELTAJ - REDUCED COST OF INCOL. */
/*     ERRS   - COPY OF ERR. */
/*     ICON   - CONTINUATION FLAG. */
/*     IFEAS  - BIAS VARIABLE USED FOR ADJUSTING K. */
/*     INCOL  - ENTERING COLUMN. */
/*     INN    - LOOPING INCOL. */
/*     INPUTS - COPY OF INPUT. */
/*     IO1    - UNIT NUMBER FOR STANDARD PRINT. */
/*     IO2    - UNIT NUMBER USED FOR PROBLEM PARAM. AND SOLN. REPORT. */
/*     IO3    - UNIT NUMBER USED FOR PROBLEM DATA AND INTERM. OUTPUT. */
/*     IOUTS  - COPY OF IOUT. */
/*     ITRY   - CUTOFF COUNTER. */
/*     IVER   - RE-INVERSION FLAG. */
/*     JIN    - PHASE. */
/*     JJOUT  - LOOPING JOUT. */
/*     JOUT   - EXITING COLUMN. */
/*     LENREQ - REQUIRED LENGTH OF WORKSPACE ARRAY WS. */
/*     LOP    - LOOPING FLAG. */
/*     M1     - M + 2. */
/*     MLE    - ROW DIM. OF BASIS INVERSE, SHOULD BE M + 2. */
/*     N1     - N FOR ALL-EQUALITY PROBLEMS, ELSE N + M. */
/*     NCALL  - NO. CALLS MADE TO LPPRIM IN PROGRAM. */
/*     NCOST  - N + M IF SLACK COSTS ASSIGNED, ELSE N. */
/*     NEQL   - NO. EQUAL OBJECTIVE VALUES. */
/*     NUMNZ  - NOT USED. */
/*     OB     - CURRENT OBJECTIVE VALUE. */
/*     RAT    - PIVOT RATIO. */
/*     SUMINF - SUM OF INFEASIBILITIES. */
/*     TOLS   - COPY OF TOL. */









/*     LPPRIM CALLS COUNTER */
    /* Parameter adjustments */
    --ws;
    --iout;
    --err;
    --dj;
    --pi;
    --jx;
    --x;
    --tol;
    --input;
    --cost;
    --rhs;
    --kt;
    --a;

    /* Function Body */


/*     INITIALIZATIONS */

    ++ncall0;
    lppzzi_1.ncall = ncall0;
    for (i__ = 1; i__ <= 4; ++i__) {
	lppzzr_1.tols[i__ - 1] = tol[i__];
	lppzzr_1.errs[i__ - 1] = 0.;
	lppzzi_1.iouts[i__ - 1] = 0;
/* L10: */
    }
    for (i__ = 1; i__ <= 19; ++i__) {
	lppzzi_1.inputs[i__ - 1] = input[i__];
/* L20: */
    }
    lppzzi_1.m1 = *m + 2;
    lppzzi_1.mle = lppzzi_1.m1;
    lppzzi_1.ncost = *n + *m * *kslack;
    lppzzi_1.n1 = *n + *m * *ialleq;
    lppzzd_1.c__ = 1e3;
    lppzzi_1.icon = 0;
    lppzzi_1.itry = 1;
    lppzzi_1.iver = -1;
    lppzzi_1.jin = 2;
    lppzzi_1.lop = 1;
    lppzzi_1.neql = 0;

/*     SET DEFAULT VALUES. */

    if (*ncut <= 0) {
	*ncut = 1000;
    }
    if (*neq <= 0) {
	*neq = 1000;
    }
    if (*nver <= 0) {
	*nver = 30;
    }
    if (*jwidth < 72) {
	*jwidth = 72;
    }
    if (*jwidth > 132) {
	*jwidth = 132;
    }
    if (*tpiv <= 0.) {
	*tpiv = 1e-7;
    }
    if (*tcost <= 0.) {
	*tcost = 1e-6;
    }
    if (*tfeas <= 0.) {
	*tfeas = 1e-6;
    }
    if (*tx <= 0.) {
	*tx = 1e-10;
    }

/*     PARTITION WORKSPACE ARRAY. */

/* Computing 2nd power */
    i__1 = lppzzi_1.mle;
    l1 = i__1 * i__1 + 1;
    lppzzi_1.lenreq = l1 + lppzzi_1.mle - 1;

/*     CALL SECOND LEVEL CONTROL ROUTINE TO SOLVE PROBLEM. */

    lpprm2_(&a[1], &kt[1], &rhs[1], &cost[1], &x[1], &jx[1], &pi[1], &dj[1], &
	    ws[1], &ws[l1]);

/*     SET EXIT VALUES, IOUT. */

/* L200: */
    for (i__ = 1; i__ <= 4; ++i__) {
	err[i__] = lppzzr_1.errs[i__ - 1];
	iout[i__] = lppzzi_1.iouts[i__ - 1];
/* L210: */
    }
    *obj = lppzzd_1.ob;

    return 0;

} /* lpprim_ */

#undef neq
#undef rowsum
#undef rowmax
#undef colsum
#undef jwidth
#undef minmax
#undef colmax
#undef tx
#undef kslack
#undef ialleq
#undef jfinal
#undef ipdata
#undef inflag
#undef nl
#undef ml
#undef numvr
#undef itryo
#undef tcost
#undef iprnt
#undef lenws
#undef tfeas
#undef iline
#undef jfile
#undef n
#undef m
#undef k
#undef tpiv
#undef nver
#undef ncut
#undef iter
#undef invc


