/* LPPRM2.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer icon, ifeas, inputs[19], incol, inn, io1, io2, io3, iouts[4], 
	    itry, iver, jin, jjout, jout, lenreq, lop, m1, mle, n1, ncall, 
	    ncost, neql, numnz;
} lppzzi_;

#define lppzzi_1 lppzzi_

struct {
    doublereal errs[4], tols[4];
} lppzzr_;

#define lppzzr_1 lppzzr_

struct {
    doublereal c__, deltaj, ob, rat, suminf;
} lppzzd_;

#define lppzzd_1 lppzzd_

/* Subroutine */ int lpprm2_(a, kt, rhs, cost, x, jx, pi, dj, e, y)
doublereal *a;
integer *kt;
doublereal *rhs, *cost, *x;
integer *jx;
doublereal *pi, *dj, *e, *y;
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
    static integer jcol;
#define invc ((integer *)&lppzzi_1 + 28)
#define iter ((integer *)&lppzzi_1 + 27)
#define ncut ((integer *)&lppzzi_1 + 11)
#define nver ((integer *)&lppzzi_1 + 13)
    static integer irow;
#define tpiv ((doublereal *)&lppzzr_1 + 4)
    static integer j;
#define k ((integer *)&lppzzi_1 + 26)
#define m ((integer *)&lppzzi_1 + 4)
#define n ((integer *)&lppzzi_1 + 5)
#define jfile ((integer *)&lppzzi_1 + 19)
#define iline ((integer *)&lppzzi_1 + 17)
#define tfeas ((doublereal *)&lppzzr_1 + 6)
#define lenws ((integer *)&lppzzi_1 + 7)
#define iprnt ((integer *)&lppzzi_1 + 15)
#define tcost ((doublereal *)&lppzzr_1 + 5)
#define itryo ((integer *)&lppzzi_1 + 14)
#define numvr ((integer *)&lppzzi_1 + 29)
#define ml ((integer *)&lppzzi_1 + 2)
#define nl ((integer *)&lppzzi_1 + 3)
#define inflag ((integer *)&lppzzi_1 + 8)
#define ipdata ((integer *)&lppzzi_1 + 16)
#define jfinal ((integer *)&lppzzi_1 + 18)
#define ialleq ((integer *)&lppzzi_1 + 9)
#define kslack ((integer *)&lppzzi_1 + 10)
#define tx ((doublereal *)&lppzzr_1 + 7)
#define colmax ((doublereal *)&lppzzr_1 + 2)
#define minmax ((integer *)&lppzzi_1 + 6)
#define jwidth ((integer *)&lppzzi_1 + 20)
    extern /* Subroutine */ int lppmod_(), lppget_(), lppmin_();
#define colsum ((doublereal *)&lppzzr_1 + 3)
    extern /* Subroutine */ int lppnew_(), lppphs_(), lpplop_(), lppver_(), 
	    lppjmy_();
#define rowmax ((doublereal *)&lppzzr_1)
    extern /* Subroutine */ int lpppiv_(), lppers_(), lpprow_();
#define rowsum ((doublereal *)&lppzzr_1 + 1)
#define neq ((integer *)&lppzzi_1 + 12)


/*     SECOND LEVEL CONTROL ROUTINE */







/*     CHANGE SIGN OF COSTS FOR MAX. PROBLEM. */

    /* Parameter adjustments */
    --y;
    --e;
    --dj;
    --pi;
    --jx;
    --x;
    --cost;
    --rhs;
    --kt;
    --a;

    /* Function Body */
    if (*minmax == 0) {
	goto L20;
    }
    i__1 = lppzzi_1.ncost;
    for (j = 1; j <= i__1; ++j) {
	cost[j] = -cost[j];
/* L10: */
    }

/*     CHECK THE BASIS CONDITION */

L20:
    if (*inflag <= 1) {
	goto L30;
    }
    lppmod_(&a[1], &kt[1], &y[1], &e[1], &cost[1], &pi[1], &jx[1], &rhs[1], &
	    x[1], &dj[1]);
    goto L50;
L30:
    if (*inflag == 0) {
	lppnew_(&a[1], &kt[1], &rhs[1], &jx[1]);
    }
L40:
    lppver_(&e[1], &jx[1], &a[1], &kt[1], &rhs[1], &x[1], &y[1], &cost[1], &
	    dj[1]);
L50:
    lppphs_(&x[1]);

/*     K = 5 IMPLIES EQUAL OBJECTIVE LIMIT-CUTOFF. */

    if (*k == 5) {
	goto L90;
    }

/*     CHECK RE-INVERSION FREQUENCY */

    if (*invc >= *nver) {
	goto L40;
    }

    lppzzi_1.iver = 1;

/*     BEGIN AN ITERATION. */

/*     GET PRICES ACCORDING TO THE PHASE. */

    lppget_(&pi[1], &e[1], &y[1]);

/*     FIND ENTERING COLUMN, RETURN THIS INDEX TO JCOL. */

    lppmin_(&jcol, &a[1], &kt[1], &cost[1], &pi[1], &jx[1]);

/*     CHECK JCOL.  K = 1 IMPLIES OPTIMAL , K = 2 IMPLIES INFEASIBLE. */

    if (jcol > 0) {
	goto L60;
    }
    *k = lppzzi_1.ifeas + 1;
    goto L90;

/*     FORM Y CORRESPONDING TO COLUMN JCOL. */

L60:
    lppjmy_(&jcol, &a[1], &kt[1], &y[1], &e[1], &cost[1]);

/*     FIND EXITING ROW, RETURN THIS INDEX TO IROW. */

    lpprow_(&irow, &jx[1], &x[1], &y[1]);

/*     CHECK IROW FOR A GOOD PIVOT.  K = 3 IMPLIES UNBOUNDED SOLUTION. */

    if (irow > 0) {
	goto L70;
    }
    *k = 3;
    goto L90;

/*     CHECK ITERATION LIMIT.  K = 4 IMPLIES ITERATION LIMIT-CUTOFF. */

L70:
    if (*iter < *ncut) {
	goto L80;
    }
    *k = 4;
    goto L90;

/*     PIVOT  ON ROW IROW TRANSFORMING E AND X  THUS ENTERING */
/*     COLUMN JCOL IN THE BASIS. */

L80:
    lpppiv_(&irow, &y[1], &x[1], &e[1]);

/*     RESET  JX, THE BASIS INDICATOR VECTOR. */
/*     UPDATE COUNTERS.  CHECK FOR LOOPING. */

    lppzzi_1.jout = jx[irow];
    lppzzi_1.incol = jcol;
    jx[irow] = jcol;
    lpplop_();
    ++(*iter);
L90:
    ++(*invc);
    lppzzd_1.suminf = -x[*m + 1];
    lppzzd_1.ob = -x[*m + lppzzi_1.jin];

    if (*k >= 1) {
	goto L100;
    }
    goto L50;

/*     END OF AN ITERATION. */

/*     CHECK FOR RETRY, I.E., REINVERT AGAIN. */

L100:
    if (*k == 2 || *k == 3 || *itryo == 1 && *k == 1) {
	goto L110;
    }
    goto L120;
L110:
    if (lppzzi_1.itry == 0) {
	goto L120;
    }
    lppzzi_1.ifeas = 0;
    *k = 0;
    lppzzi_1.itry = 0;
    goto L40;

/*     COMPUTE ROW, COLUMN ERRORS, AND REDUCED COSTS AT SOLUTION. */

L120:
    lppers_(&jx[1], &a[1], &kt[1], &cost[1], &rhs[1], &pi[1], &x[1], &dj[1]);

/*     RESTORE SIGN OF COSTS, CHANGE SIGN OF OBJECTIVE AND PI */
/*     FOR MAX. PROBLEM. */

    if (*minmax == 0) {
	goto L150;
    }
    i__1 = lppzzi_1.ncost;
    for (j = 1; j <= i__1; ++j) {
	cost[j] = -cost[j];
/* L130: */
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	pi[j] = -pi[j];
/* L140: */
    }
    if (*k == 1 || lppzzi_1.jin == 2) {
	lppzzd_1.ob = -lppzzd_1.ob;
    }

L150:

/*     IF OPTIMAL, RESET ANY INSIGNIFICANT X AND PI VALUES TO ZERO. */

    if (*k != 1) {
	goto L170;
    }
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
	if ((d__1 = x[j], abs(d__1)) < *tx) {
	    x[j] = 0.;
	}
	if ((d__1 = pi[j], abs(d__1)) < *tx) {
	    pi[j] = 0.;
	}
/* L160: */
    }

L170:
    return 0;

} /* lpprm2_ */

#undef neq
#undef rowsum
#undef rowmax
#undef colsum
#undef jwidth
#undef minmax
#undef colmax
#undef tx
#undef kslack
#undef ialleq
#undef jfinal
#undef ipdata
#undef inflag
#undef nl
#undef ml
#undef numvr
#undef itryo
#undef tcost
#undef iprnt
#undef lenws
#undef tfeas
#undef iline
#undef jfile
#undef n
#undef m
#undef k
#undef tpiv
#undef nver
#undef ncut
#undef iter
#undef invc


