/* LPPJMY.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer icon, ifeas, inputs[19], incol, inn, io1, io2, io3, iouts[4], 
	    itry, iver, jin, jjout, jout, lenreq, lop, m1, mle, n1, ncall, 
	    ncost, neql, numnz;
} lppzzi_;

#define lppzzi_1 lppzzi_

struct {
    doublereal errs[4], tols[4];
} lppzzr_;

#define lppzzr_1 lppzzr_

/* Subroutine */ int lppjmy_(j, a, kt, y, e, cost)
integer *j;
doublereal *a;
integer *kt;
doublereal *y, *e, *cost;
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;

    /* Local variables */
#define invc ((integer *)&lppzzi_1 + 28)
#define iter ((integer *)&lppzzi_1 + 27)
#define ncut ((integer *)&lppzzi_1 + 11)
#define nver ((integer *)&lppzzi_1 + 13)
#define tpiv ((doublereal *)&lppzzr_1 + 4)
    static integer i__;
#define k ((integer *)&lppzzi_1 + 26)
#define m ((integer *)&lppzzi_1 + 4)
#define n ((integer *)&lppzzi_1 + 5)
#define jfile ((integer *)&lppzzi_1 + 19)
#define iline ((integer *)&lppzzi_1 + 17)
#define tfeas ((doublereal *)&lppzzr_1 + 6)
#define lenws ((integer *)&lppzzi_1 + 7)
#define iprnt ((integer *)&lppzzi_1 + 15)
#define tcost ((doublereal *)&lppzzr_1 + 5)
    static integer j1;
#define itryo ((integer *)&lppzzi_1 + 14)
#define numvr ((integer *)&lppzzi_1 + 29)
    static integer ii, jj, in;
#define ml ((integer *)&lppzzi_1 + 2)
#define nl ((integer *)&lppzzi_1 + 3)
    static integer mm;
#define inflag ((integer *)&lppzzi_1 + 8)
#define ipdata ((integer *)&lppzzi_1 + 16)
#define jfinal ((integer *)&lppzzi_1 + 18)
#define ialleq ((integer *)&lppzzi_1 + 9)
#define kslack ((integer *)&lppzzi_1 + 10)
#define tx ((doublereal *)&lppzzr_1 + 7)
#define colmax ((doublereal *)&lppzzr_1 + 2)
#define minmax ((integer *)&lppzzi_1 + 6)
#define jwidth ((integer *)&lppzzi_1 + 20)
#define colsum ((doublereal *)&lppzzr_1 + 3)
#define rowmax ((doublereal *)&lppzzr_1)
#define rowsum ((doublereal *)&lppzzr_1 + 1)
    static integer iii;
#define neq ((integer *)&lppzzi_1 + 12)
    static integer mmm;


/*     J MULTIPLY BASIS INVERSE., I.E., E TIMES COLUMN J. */






/*     PUT CONTENTS IN Y */

    /* Parameter adjustments */
    --cost;
    --e;
    --y;
    --kt;
    --a;

    /* Function Body */
    jj = *j;
    i__1 = lppzzi_1.m1;
    for (j1 = 1; j1 <= i__1; ++j1) {
	y[j1] = 0.;
/* L50: */
    }
    if (jj > *n) {
	goto L200;
    }
    mm = (jj - 1) * *ml;
    i__1 = lppzzi_1.m1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	mmm = 0;
	i__2 = *m;
	for (j1 = 1; j1 <= i__2; ++j1) {
	    ii = j1 + mm;
	    if (a[ii] == 0.) {
		goto L90;
	    }
	    iii = i__ + mmm;
	    if ((d__1 = e[iii], abs(d__1)) <= *tx) {
		goto L90;
	    }
	    y[i__] += a[ii] * e[iii];
L90:
	    mmm += lppzzi_1.mle;
/* L100: */
	}
/* L150: */
    }
    y[lppzzi_1.m1] += cost[jj];
    goto L300;

/*     FOR SLACK COLUMNS */

L200:
    in = jj - *n;
    if (kt[in] == 0) {
	goto L300;
    }
    mm = (in - 1) * lppzzi_1.mle;
    i__1 = lppzzi_1.m1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	iii = i__ + mm;
	if ((d__1 = e[iii], abs(d__1)) <= *tx) {
	    goto L250;
	}
	y[i__] = e[iii] * (doublereal) kt[in];
L250:
	;
    }
    if (*kslack == 0) {
	goto L300;
    }
    y[lppzzi_1.m1] += cost[jj];

L300:
    return 0;

} /* lppjmy_ */

#undef neq
#undef rowsum
#undef rowmax
#undef colsum
#undef jwidth
#undef minmax
#undef colmax
#undef tx
#undef kslack
#undef ialleq
#undef jfinal
#undef ipdata
#undef inflag
#undef nl
#undef ml
#undef numvr
#undef itryo
#undef tcost
#undef iprnt
#undef lenws
#undef tfeas
#undef iline
#undef jfile
#undef n
#undef m
#undef k
#undef tpiv
#undef nver
#undef ncut
#undef iter
#undef invc


