/* LPPMOD.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer icon, ifeas, inputs[19], incol, inn, io1, io2, io3, iouts[4], 
	    itry, iver, jin, jjout, jout, lenreq, lop, m1, mle, n1, ncall, 
	    ncost, neql, numnz;
} lppzzi_;

#define lppzzi_1 lppzzi_

struct {
    doublereal errs[4], tols[4];
} lppzzr_;

#define lppzzr_1 lppzzr_

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int lppmod_(a, kt, y, e, cost, pi, jx, rhs, x, dj)
doublereal *a;
integer *kt;
doublereal *y, *e, *cost, *pi;
integer *jx;
doublereal *rhs, *x, *dj;
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
#define invc ((integer *)&lppzzi_1 + 28)
#define iter ((integer *)&lppzzi_1 + 27)
#define ncut ((integer *)&lppzzi_1 + 11)
#define nver ((integer *)&lppzzi_1 + 13)
#define tpiv ((doublereal *)&lppzzr_1 + 4)
    static integer i__;
#define k ((integer *)&lppzzi_1 + 26)
    static integer l;
#define m ((integer *)&lppzzi_1 + 4)
#define n ((integer *)&lppzzi_1 + 5)
#define jfile ((integer *)&lppzzi_1 + 19)
#define iline ((integer *)&lppzzi_1 + 17)
#define tfeas ((doublereal *)&lppzzr_1 + 6)
#define lenws ((integer *)&lppzzi_1 + 7)
#define iprnt ((integer *)&lppzzi_1 + 15)
#define tcost ((doublereal *)&lppzzr_1 + 5)
#define itryo ((integer *)&lppzzi_1 + 14)
#define numvr ((integer *)&lppzzi_1 + 29)
    static doublereal cc;
    extern /* Subroutine */ int lppgt1_(), lppvr1_();
#define ml ((integer *)&lppzzi_1 + 2)
#define nl ((integer *)&lppzzi_1 + 3)
#define inflag ((integer *)&lppzzi_1 + 8)
#define ipdata ((integer *)&lppzzi_1 + 16)
#define jfinal ((integer *)&lppzzi_1 + 18)
#define ialleq ((integer *)&lppzzi_1 + 9)
#define kslack ((integer *)&lppzzi_1 + 10)
#define tx ((doublereal *)&lppzzr_1 + 7)
#define colmax ((doublereal *)&lppzzr_1 + 2)
#define minmax ((integer *)&lppzzi_1 + 6)
#define jwidth ((integer *)&lppzzi_1 + 20)
#define colsum ((doublereal *)&lppzzr_1 + 3)
    extern /* Subroutine */ int lppjmy_();
#define rowmax ((doublereal *)&lppzzr_1)
#define rowsum ((doublereal *)&lppzzr_1 + 1)
#define neq ((integer *)&lppzzi_1 + 12)


/*     MODIFIES  X  AND/OR PI  FOR CHANGES IN RHS AND/OR COST */
/*     WITHOUT REINVERSION */






    /* Parameter adjustments */
    --dj;
    --x;
    --rhs;
    --jx;
    --pi;
    --cost;
    --e;
    --y;
    --kt;
    --a;

    /* Function Body */
    if (*inflag == 3) {
	goto L30;
    }

/*     GET THE NEW PI AND PUT C-B IN Y. */

    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	y[i__] = 0.;
	l = jx[i__];
	if (l == 0) {
	    goto L10;
	}
	if (l > *n && *kslack == 0) {
	    goto L10;
	}
	y[i__] = cost[l];
L10:
	;
    }
    lppgt1_(&pi[1], &e[1], &y[1]);
    if (*inflag == 2) {
	goto L30;
    }

/*     CALCULATE THE X(M1),THE NEW Z-BAR */

    x[lppzzi_1.m1] = 0.;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if ((d__1 = pi[i__], abs(d__1)) <= *tx) {
	    goto L20;
	}
	if ((d__1 = rhs[i__], abs(d__1)) <= *tx) {
	    goto L20;
	}
	x[lppzzi_1.m1] += pi[i__] * rhs[i__];
L20:
	;
    }
    goto L70;

/*     REPLACE COL. 1 OF A BY RHS, SAVE COL. 1 IN DJ. */
/*     PREPARE TO USE LPPJMY TO FIND THE NEW X. */

L30:
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	dj[i__] = a[i__];
	a[i__] = rhs[i__];
/* L40: */
    }
    cc = cost[1];
    cost[1] = 0.;
    lppjmy_(&c__1, &a[1], &kt[1], &y[1], &e[1], &cost[1]);

/*     RESTORE COL. 1 OF A, ETC. */

    cost[1] = cc;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	a[i__] = dj[i__];
/* L50: */
    }
    i__1 = lppzzi_1.m1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	x[i__] = y[i__];
/* L60: */
    }

/*     DETERMINE FEASIBILITY */

    lppvr1_(&e[1], &jx[1], &a[1], &kt[1], &rhs[1], &x[1], &y[1], &cost[1], &
	    dj[1]);

L70:
    return 0;

} /* lppmod_ */

#undef neq
#undef rowsum
#undef rowmax
#undef colsum
#undef jwidth
#undef minmax
#undef colmax
#undef tx
#undef kslack
#undef ialleq
#undef jfinal
#undef ipdata
#undef inflag
#undef nl
#undef ml
#undef numvr
#undef itryo
#undef tcost
#undef iprnt
#undef lenws
#undef tfeas
#undef iline
#undef jfile
#undef n
#undef m
#undef k
#undef tpiv
#undef nver
#undef ncut
#undef iter
#undef invc


