/* LPPROW.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer icon, ifeas, inputs[19], incol, inn, io1, io2, io3, iouts[4], 
	    itry, iver, jin, jjout, jout, lenreq, lop, m1, mle, n1, ncall, 
	    ncost, neql, numnz;
} lppzzi_;

#define lppzzi_1 lppzzi_

struct {
    doublereal errs[4], tols[4];
} lppzzr_;

#define lppzzr_1 lppzzr_

struct {
    doublereal c__, deltaj, ob, rat, suminf;
} lppzzd_;

#define lppzzd_1 lppzzd_

/* Subroutine */ int lpprow_(irow, jx, x, y)
integer *irow, *jx;
doublereal *x, *y;
{
    /* Initialized data */

    static doublereal zseed = 123457.;
    static doublereal zmod = 2147483647.;
    static doublereal zmult = 16807.;
    static doublereal zscale = 2147483648.;

    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Builtin functions */
    double d_mod();

    /* Local variables */
    static integer itie;
#define invc ((integer *)&lppzzi_1 + 28)
#define iter ((integer *)&lppzzi_1 + 27)
#define ncut ((integer *)&lppzzi_1 + 11)
#define nver ((integer *)&lppzzi_1 + 13)
    static integer ifry;
#define tpiv ((doublereal *)&lppzzr_1 + 4)
    static integer i__;
#define k ((integer *)&lppzzi_1 + 26)
#define m ((integer *)&lppzzi_1 + 4)
#define n ((integer *)&lppzzi_1 + 5)
    static doublereal r__;
#define jfile ((integer *)&lppzzi_1 + 19)
#define iline ((integer *)&lppzzi_1 + 17)
#define tfeas ((doublereal *)&lppzzr_1 + 6)
    static doublereal ratio;
#define lenws ((integer *)&lppzzi_1 + 7)
#define iprnt ((integer *)&lppzzi_1 + 15)
#define tcost ((doublereal *)&lppzzr_1 + 5)
#define itryo ((integer *)&lppzzi_1 + 14)
#define numvr ((integer *)&lppzzi_1 + 29)
#define ml ((integer *)&lppzzi_1 + 2)
#define nl ((integer *)&lppzzi_1 + 3)
#define inflag ((integer *)&lppzzi_1 + 8)
#define ipdata ((integer *)&lppzzi_1 + 16)
#define jfinal ((integer *)&lppzzi_1 + 18)
    static doublereal ss;
#define ialleq ((integer *)&lppzzi_1 + 9)
#define kslack ((integer *)&lppzzi_1 + 10)
#define tx ((doublereal *)&lppzzr_1 + 7)
#define colmax ((doublereal *)&lppzzr_1 + 2)
#define minmax ((integer *)&lppzzi_1 + 6)
#define jwidth ((integer *)&lppzzi_1 + 20)
#define colsum ((doublereal *)&lppzzr_1 + 3)
#define rowmax ((doublereal *)&lppzzr_1)
#define rowsum ((doublereal *)&lppzzr_1 + 1)
    static doublereal com;
#define neq ((integer *)&lppzzi_1 + 12)


/*     SELECTS THE EXITING COLUMN... TIES BROKEN 'RANDOMLY'. */






/*     CONSTANTS FOR RANDOM NO. GENERATION */

    /* Parameter adjustments */
    --y;
    --x;
    --jx;

    /* Function Body */


/*     LOOK FOR ADMISSIBLE ARTIFICALS AT ZERO LEVEL.  TX IS X FEASIBILITY.
 */
/*     TAKE LARGEST CORRESPONDING Y(I) IN ABSOLUTE VALUE FOR ACCURACCY. */

    lppzzd_1.rat = 0.;
    *irow = 0;
    com = *tpiv;
    i__1 = *m;

    for (i__ = 1; i__ <= i__1; ++i__) {
	if (x[i__] <= *tx && jx[i__] == 0) {
	    goto L110;
	}
	goto L120;
L110:
	if ((d__1 = y[i__], abs(d__1)) <= com) {
	    goto L120;
	}
	*irow = i__;
	com = (d__1 = y[i__], abs(d__1));
	lppzzd_1.rat = x[i__] / y[i__];
L120:
	;
    }
    if (*irow > 0) {
	goto L500;
    }

/*    LOOK FOR ADMISSIBLE REALS AT ZERO LEVEL.  BREAK TIES RANDOMLY.*/
/*     TAKE LARGEST PPOSTIVE Y(I) FOR ACCURACY. */

    ifry = 1;
    lppzzd_1.rat = 0.;
    com = *tpiv;
    itie = 0;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (x[i__] <= *tx && jx[i__] > 0 && y[i__] > *tpiv) {
	    goto L210;
	}
	goto L240;
L210:
	if (ifry == 1) {
	     ifry = 0;
	     goto L230;
	}
	if ((d__1 = y[i__] - com) < 0.) {
	    goto L240;
	} else if (d__1 == 0) {
	    goto L220;
	} else {
	    goto L230;
	}
L220:
	++itie;
	ss = (doublereal) itie;
	ss = 1. / ss;
	d__1 = zmult * zseed;
	zseed = d_mod(&d__1, &zmod);
	r__ = zseed / zscale;
	if (r__ <= ss) {
	    *irow = i__;
	}
	goto L240;
L230:
	com = y[i__];
	*irow = i__;
	itie = 0;
L240:
	;
    }
    if (*irow == 0) {
	goto L300;
    }
    lppzzd_1.rat = x[*irow] / y[*irow];
    goto L500;

/*     LOOK FOR ADMISSIBLE ARTIFICALS AT POSITIVE LEVEL. */
/*     FIND MIN X/Y RATIO. */
/*     IFRY IS A FLAG FOR GETTING AT LEAST ONE ADMISSIBLE RATIO. */

L300:
    *irow = 0;
    ifry = 1;
    i__1 = *m;

    for (i__ = 1; i__ <= i__1; ++i__) {
	if (jx[i__] == 0 && x[i__] > *tx && y[i__] > *tpiv) {
	    goto L310;
	}
	goto L320;
L310:
	ratio = x[i__] / y[i__];
	if (ifry == 1) {
	    com = ratio;
	    *irow = i__;
	}
	ifry = 0;
	if (ratio > com) {
	    goto L320;
	}
	*irow = i__;
	com = ratio;
L320:
	;
    }

/*    NEXT LOOK AT REALS AT POS. LEVEL.  FIND OVERALL MIN. X/Y RATIO.*/
/*     AT THIS POINT IF IFRY=1 THEN THERE WERE NO ADM. ARTS. AT POST. */
/*    HENCE THE MIN. X/Y RATIO WILL BE OVER THE REALS AT POS. LEVEL.*/

    itie = 0;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (jx[i__] > 0 && x[i__] > *tx && y[i__] > *tpiv) {
	    goto L410;
	}
	goto L440;
L410:
	ratio = x[i__] / y[i__];
	if (ifry == 1) {
	     ifry = 0;
	     goto L430;
	}
	if ((d__1 = ratio - com) < 0.) {
	    goto L430;
	} else if (d__1 == 0) {
	    goto L420;
	} else {
	    goto L440;
	}
L420:
	++itie;
	ss = (doublereal) itie;
	ss = 1. / ss;
	d__1 = zmult * zseed;
	zseed = d_mod(&d__1, &zmod);
	r__ = zseed / zscale;
	if (r__ <= ss) {
	    *irow = i__;
	}
	goto L440;
L430:
	com = ratio;
	*irow = i__;
	itie = 0;
L440:
	;
    }
    lppzzd_1.rat = com;

L500:
    return 0;

} /* lpprow_ */

#undef neq
#undef rowsum
#undef rowmax
#undef colsum
#undef jwidth
#undef minmax
#undef colmax
#undef tx
#undef kslack
#undef ialleq
#undef jfinal
#undef ipdata
#undef inflag
#undef nl
#undef ml
#undef numvr
#undef itryo
#undef tcost
#undef iprnt
#undef lenws
#undef tfeas
#undef iline
#undef jfile
#undef n
#undef m
#undef k
#undef tpiv
#undef nver
#undef ncut
#undef iter
#undef invc


