/* LPPVER.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer icon, ifeas, inputs[19], incol, inn, io1, io2, io3, iouts[4], 
	    itry, iver, jin, jjout, jout, lenreq, lop, m1, mle, n1, ncall, 
	    ncost, neql, numnz;
} lppzzi_;

#define lppzzi_1 lppzzi_

struct {
    doublereal errs[4], tols[4];
} lppzzr_;

#define lppzzr_1 lppzzr_

struct {
    doublereal c__, deltaj, ob, rat, suminf;
} lppzzd_;

#define lppzzd_1 lppzzd_

/* Subroutine */ int lppver_0_(n__, e, jx, a, kt, rhs, x, y, cost, is)
int n__;
doublereal *e;
integer *jx;
doublereal *a;
integer *kt;
doublereal *rhs, *x, *y, *cost;
integer *is;
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;

    /* Local variables */
    static integer jneg;
#define invc ((integer *)&lppzzi_1 + 28)
    static integer indx;
#define iter ((integer *)&lppzzi_1 + 27)
#define ncut ((integer *)&lppzzi_1 + 11)
#define nver ((integer *)&lppzzi_1 + 13)
#define tpiv ((doublereal *)&lppzzr_1 + 4)
    static integer i__, j;
#define k ((integer *)&lppzzi_1 + 26)
    static integer l;
#define m ((integer *)&lppzzi_1 + 4)
#define n ((integer *)&lppzzi_1 + 5)
#define jfile ((integer *)&lppzzi_1 + 19)
#define iline ((integer *)&lppzzi_1 + 17)
#define tfeas ((doublereal *)&lppzzr_1 + 6)
#define lenws ((integer *)&lppzzi_1 + 7)
#define iprnt ((integer *)&lppzzi_1 + 15)
#define tcost ((doublereal *)&lppzzr_1 + 5)
    static integer m2;
#define itryo ((integer *)&lppzzi_1 + 14)
#define numvr ((integer *)&lppzzi_1 + 29)
    static doublereal cc;
    static integer ii, ij, il, ll;
#define ml ((integer *)&lppzzi_1 + 2)
#define nl ((integer *)&lppzzi_1 + 3)
    static integer mm;
#define inflag ((integer *)&lppzzi_1 + 8)
#define ipdata ((integer *)&lppzzi_1 + 16)
#define jfinal ((integer *)&lppzzi_1 + 18)
    static doublereal rr;
#define ialleq ((integer *)&lppzzi_1 + 9)
#define kslack ((integer *)&lppzzi_1 + 10)
    static doublereal ss, tt;
#define tx ((doublereal *)&lppzzr_1 + 7)
#define colmax ((doublereal *)&lppzzr_1 + 2)
#define minmax ((integer *)&lppzzi_1 + 6)
#define jwidth ((integer *)&lppzzi_1 + 20)
#define colsum ((doublereal *)&lppzzr_1 + 3)
    extern /* Subroutine */ int lppjmy_();
#define rowmax ((doublereal *)&lppzzr_1)
    extern /* Subroutine */ int lpppiv_();
#define rowsum ((doublereal *)&lppzzr_1 + 1)
    static integer iee, iii, ijj;
    static doublereal com;
#define neq ((integer *)&lppzzi_1 + 12)


/*     FORMS THE INVERSE E. */
/*     WE THINK OF E AS A (M+2)*M MATRIX WITH THE FIRST M*M BLOCK = */
/*     THE INVERSE OF THE BASIS ....... AND .............. */
/*     ROW M+1 = PI FOR THE ART. IN BASIS = -COST OF ART-SUB B*B INVERSE 
*/
/*     ROW M+2 = PI FOR BASIS = -COSTSUB B*B INVERSE */







/*     USE IS AS A BASIC COLUMN INDICATOR.  ZERO OUT E. */
/*     USE M+1 COLUMN OF E AS PIVOT LIST.   C EQUALS 1000.0 */

    /* Parameter adjustments */
    --e;
    --jx;
    --a;
    --kt;
    --rhs;
    --x;
    --y;
    --cost;
    --is;

    /* Function Body */
    switch(n__) {
	case 1: goto L_lppvr1;
	}

    ll = *m * lppzzi_1.mle;
    lppzzi_1.lop = 1;
    i__1 = lppzzi_1.n1;
    for (j = 1; j <= i__1; ++j) {
	is[j] = 0;
/* L50: */
    }
/* Computing 2nd power */
    i__1 = lppzzi_1.mle;
    m2 = i__1 * i__1;
    *invc = 0;
    ++(*numvr);
    i__1 = m2;
    for (i__ = 1; i__ <= i__1; ++i__) {
	e[i__] = 0.;
/* L100: */
    }

/*     INIALIZE X. */

    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	x[i__] = rhs[i__];
/* L150: */
    }
    x[*m + 2] = 0.;
    x[*m + 1] = 0.;

/*     PUT E INTO IDENTITY FORM. */

    mm = 0;
    i__1 = lppzzi_1.m1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ii = i__ + mm;
	e[ii] = 1.;
	mm += lppzzi_1.mle;
/* L200: */
    }

/*     FOR THE FIRST INVERSION ONLY, */
/*     REPLACE AS MANY OF THE ARTIFICIALS IN JX BY NON ZERO SLACKS */
/*     FROM KT ARRAY. */

    if (*numvr > 1) {
	goto L260;
    }
    if (*ialleq == 0) {
	goto L260;
    }
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (kt[i__] == 0) {
	    goto L250;
	}
	if (jx[i__] > 0) {
	    goto L250;
	}
	ss = rhs[i__] * kt[i__];
	if (ss < 0.) {
	    goto L250;
	}
	l = *n + i__;
	i__2 = *m;
	for (j = 1; j <= i__2; ++j) {
	    if (jx[j] == l) {
		goto L250;
	    }
/* L220: */
	}
	jx[i__] = l;
	is[l] = i__;
	e[i__ + ll] = lppzzd_1.c__;
	ii = i__ + (i__ - 1) * lppzzi_1.mle;
	iii = lppzzi_1.m1 + (i__ - 1) * lppzzi_1.mle;
	e[ii] = (doublereal) kt[i__];
	x[i__] = rhs[i__] * (doublereal) kt[i__];
	if (*kslack == 0) {
	    goto L250;
	}
	cc = cost[l];
	e[iii] = -cc * (doublereal) kt[i__];
	x[lppzzi_1.m1] -= cc * x[i__];
L250:
	;
    }
L260:

/*     INSTALL ARTIFICIALS IN THE BASIS NEXT */

    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (jx[i__] > 0) {
	    goto L300;
	}
	e[i__ + ll] = lppzzd_1.c__;
	ii = i__ + (i__ - 1) * lppzzi_1.mle;
	iii = *m + 1 + (i__ - 1) * lppzzi_1.mle;
	rr = rhs[i__];
	tt = 1.;
	if (rr < 0.) {
	    tt = -1.;
	}
	e[ii] = tt;
	e[iii] = -tt;
	x[i__] = tt * rr;
	x[*m + 1] -= x[i__];
L300:
	;
    }

/*     INSTALL AS MUCH OF THE REST OF THE ORIGINAL BASIS IN THE NEW */
/*     BASIS  AS  POSSIBLE. */

    i__1 = *m;
    for (ij = 1; ij <= i__1; ++ij) {
	j = jx[ij];
	if (j == 0) {
	    goto L420;
	}
	lppjmy_(&j, &a[1], &kt[1], &y[1], &e[1], &cost[1]);

/*        SET TO ZERO SMALL NO.S IN Y. */

	i__2 = *m;
	for (ijj = 1; ijj <= i__2; ++ijj) {
	    if ((d__1 = y[ijj], abs(d__1)) > *tx) {
		goto L400;
	    }
	    y[ijj] = 0.;
L400:
	    ;
	}

/*       FIND LARGEST ABS(Y(I)) FOR UNUSED PIVOT LOCATIONS (FOR ACCURA
CY).*/

	indx = 0;
	com = *tpiv;
	i__2 = *m;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    iee = (integer) e[i__ + ll];
	    if (iee != 0) {
		goto L410;
	    }
	    if ((d__1 = y[i__], abs(d__1)) < com) {
		goto L410;
	    }
	    indx = i__;
	    com = (d__1 = y[i__], abs(d__1));
L410:
	    ;
	}
	if (indx == 0) {
	    goto L420;
	}
	if (com <= *tpiv) {
	    goto L420;
	}
	lpppiv_(&indx, &y[1], &x[1], &e[1]);
	is[j] = indx;
	e[indx + ll] = lppzzd_1.c__;
L420:
	;
    }

/*     PUT IN THE REMAINING ARTIFICIALS. */
/*     E(I+LL) = 0.0  MEANS I IS AUNUSED PIVOT LOCATION. */

    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	iee = (integer) e[i__ + ll];
	if (iee != 0) {
	    goto L510;
	}

/*        INIALIZE Y. */

	i__2 = lppzzi_1.m1;
	for (ii = 1; ii <= i__2; ++ii) {
	    y[ii] = 0.;
/* L500: */
	}
	y[*m + 1] = 1.;
	y[i__] = -1.;
	if (x[i__] >= 0.) {
	    y[i__] = 1.;
	}
	lpppiv_(&i__, &y[1], &x[1], &e[1]);
L510:
	;
    }

/*     DETERMINE JX LIST. */

/* L520: */
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	e[i__ + ll] = 0.;
	jx[i__] = 0;
/* L530: */
    }
    i__1 = lppzzi_1.n1;
    for (j = 1; j <= i__1; ++j) {
	il = is[j];
	if (il > 0) {
	    jx[il] = j;
	}
/* L540: */
    }

/*     HAVE A FULL BASIS AT THIS POINT. CHECK FOR X-FEASIBILITY. */
/*     IF NOT FEASIBLE PUT IN AN ART. COL. */

/* .......................................................................
 */


L_lppvr1:

/*     LPPVR1 IS USED BY LPPMOD TO INSTALL ARTIFICIAL */

    indx = 0;
    y[*m + 1] = 1.;
    y[*m + 2] = 0.;
    com = *tx;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	y[i__] = 0.;
	if (x[i__] >= 0.) {
	    goto L700;
	}
	y[i__] = -1.;
	jneg = jx[i__];
	if (jneg == 0) {
	    y[*m + 1] += 1.;
	}
	if (jneg > *n && *kslack == 0) {
	    goto L600;
	}
	if (jneg == 0) {
	    goto L600;
	}
	y[*m + 2] += cost[jneg];
L600:
	if (x[i__] >= com) {
	    goto L700;
	}
	indx = i__;
	com = x[i__];
L700:
	;
    }
    if (indx == 0) {
	goto L800;
    }
    lpppiv_(&indx, &y[1], &x[1], &e[1]);
    jx[indx] = 0;

/*     DETERMINE THE PHASE. */

L800:
    lppzzd_1.suminf = -x[*m + 1];
    lppzzi_1.jin = 1;
    if (abs(lppzzd_1.suminf) <= *tfeas) {
	lppzzi_1.jin = 2;
    }
    lppzzd_1.ob = -x[*m + lppzzi_1.jin];

    return 0;

} /* lppver_ */

#undef neq
#undef rowsum
#undef rowmax
#undef colsum
#undef jwidth
#undef minmax
#undef colmax
#undef tx
#undef kslack
#undef ialleq
#undef jfinal
#undef ipdata
#undef inflag
#undef nl
#undef ml
#undef numvr
#undef itryo
#undef tcost
#undef iprnt
#undef lenws
#undef tfeas
#undef iline
#undef jfile
#undef n
#undef m
#undef k
#undef tpiv
#undef nver
#undef ncut
#undef iter
#undef invc


/* Subroutine */ int lppver_(e, jx, a, kt, rhs, x, y, cost, is)
doublereal *e;
integer *jx;
doublereal *a;
integer *kt;
doublereal *rhs, *x, *y, *cost;
integer *is;
{
    return lppver_0_(0, e, jx, a, kt, rhs, x, y, cost, is);
    }

/* Subroutine */ int lppvr1_(e, jx, a, kt, rhs, x, y, cost, is)
doublereal *e;
integer *jx;
doublereal *a;
integer *kt;
doublereal *rhs, *x, *y, *cost;
integer *is;
{
    return lppver_0_(1, e, jx, a, kt, rhs, x, y, cost, is);
    }

